<?php
/*
Plugin Name: Simple Capability Editor
Plugin URI: http://zaantar.eu/index.php?page=Simple+Capability+Editor
Description: Velmi jednoduchá utilitka na správu uživatelských rolí a oprávnění.
Version: 1.3
Author: Zaantar
Author URI: http://zaantar.eu
License: GPL2
*/

/*
    Copyright 2010 Zaantar (email: zaantar@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* ************************************************************************* *\
    WORDPRESS HOOKS, MENUS
\* ************************************************************************* */

add_action( 'admin_menu','sce_add_admin_menus' );

function sce_add_admin_menus() {
    add_submenu_page('tools.php','Simple Capability Editor','SCE', 'promote_users', 'sce-page', 'sce_page');
}

/* ************************************************************************* *\
    MAIN PLUGIN PAGE
\* ************************************************************************* */

function sce_page() {
    /* podle akce zobrazíme příslušnou stránku */
    $action = 'main';
    if( isset($_POST['action']) ) {
        $action = $_POST['action'];
    }
    $role = '';
    if( isset($_POST['role']) ) {
        $role = $_POST['role'];
    }
    if( $role == '0' ) {
        $role = $_POST['new_role'];
    }
    
    switch( $action ) {
        case 'decision':
            if( isset($_POST['add_role']) ) {
                sce_add_role_page( $role );
            } else if( isset($_POST['rem_role']) ) {
                sce_rem_role_page( $role );
            }else if( isset($_POST['add_cap']) ) {
                sce_add_cap_page( $role, $_POST['cap'] );
            }else if( isset($_POST['rem_cap']) ) {
                sce_rem_cap_page( $role, $_POST['cap'] );
            }
            break;
        case 'main':
        default:
            sce_main_page();
            break;
    }
}

function sce_main_page() {
    ?>
    <div class="wrap">
        <h2>Simple Capability Editor</h2>
        <?php
        sce_print_error( '<strong>UPOZORNĚNÍ!</strong> Nepoužívejte tento plugin, pokud nevíte, co děláte. <br><br>Je velmi snadné chybnou volbou poškodit fungování webu. <strong>Pokud si čímkoliv nejste jistí, kontaktujte webmastera.</strong>' );
        ?>
        <form method="post" action="tools.php?page=sce-page">
            <input type="hidden" name="action" value="decision" />
            <table class="form-table">
                <tr valign="top">
                    <th scope="row">Role</th>
                    <td>
                        <select name="role">
                            <option value="0">--&gt;</option>
                            <?php sce_print_role_options(); ?>
                        </select>
                        <input type="text" name="new_role" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row">Capability</th>
                    <td><input type="text" name="cap" /></td>
                </tr>
            </table>
            <p class="submit">
                <input type="submit" class="button-secondary" name="add_role" value="Přidat roli" />
                <input type="submit" class="button-secondary" name="rem_role" value="Odstranit roli" />
                <input type="submit" class="button-secondary" name="add_cap" value="Přidat capability do role" />
                <input type="submit" class="button-secondary" name="rem_cap" value="Odebrat capability z role" />
            </p>
        </form>
        <h3>Seznam uživatelských rolí ve WordPressu:</h3>
        <p><?php sce_print_roles(); ?></p>
    </div>
    <?php
}

/* vypíše názvy uživatelských rolí oddělené čárkou */
function sce_print_roles() {
    global $wp_roles;
    foreach( $wp_roles->role_objects as $role ) {
        echo( '<strong>'.$role->name.'</strong> './*$role->displayname.*/' ( <em><small>' );
        sce_print_caps( $role->name );
        echo( '</small></em>)<br><br>' );
    }
}

function sce_print_caps( $rolename ) {
    $role = get_role( $rolename );
    foreach( $role->capabilities as $capability => $name ) {
        echo ( $capability.' ' );
    }
}

function sce_print_nag( $message ) {
    echo('<div id="message" class="updated"><p>'.$message.'</p></div>');
}

function sce_print_error( $message ) {
    echo('<div id="message" class="error"><p>'.$message.'</p></div>');
}

function sce_print_role_options( $message ) {
    global $wp_roles;
    foreach( $wp_roles->role_names as $role => $name ) {
        echo( '<option value="'.$role.'">'.$role.'</option>' );
    }
}

/* ************************************************************************* *\
    FUNCTIONALITY
\* ************************************************************************* */

function sce_add_role_page( $role_name ) {
    $role_slug = strtolower( $role_name );
    add_role( $role_slug, $role_name );
    sce_print_nag('Role <strong>'.$role_name.'</strong> byla úspěšně přidána do systému.');
    sce_main_page();
}

function sce_rem_role_page( $role_name ) {
    remove_role( $role_name );
    sce_print_nag('Role <strong>'.$role_name.'</strong> byla úspěšně odstraněna ze systému.');
    sce_main_page();
}

function sce_add_cap_page( $role_name, $cap_name ) {
    $role = get_role( $role_name );
    $role->add_cap( $cap_name );
    sce_print_nag('Capability <strong>'.$cap_name.'</strong> byla úspěšně přidána do role <strong>'.$role_name.'</strong>.' );
    sce_main_page();
}

function sce_rem_cap_page( $role_name, $cap_name ) {
    $role = get_role( $role_name );
    $role->remove_cap( $cap_name );
    sce_print_nag('Capability <strong>'.$cap_name.'</strong> byla úspěšně odebrána z role <strong>'.$role_name.'</strong>.' );
    sce_main_page();
}

?>
